"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const svg_1 = require("../assets/svg");
require("./Pagination.scss");
const react_1 = __importDefault(require("react"));
function TanstackPagination({ table }) {
    // const rowsPerPageArray = [25, 50, 100];
    const pageIndex = table.getState().pagination.pageIndex + 1;
    const pageCount = table.getPageCount();
    const pageSize = table.getState().pagination.pageSize;
    const recordsRangeFirst = pageIndex * pageSize - pageSize + 1;
    const recordsRangeLast = pageIndex * pageSize;
    const recordsTotal = pageCount * pageSize;
    return (react_1.default.createElement("div", { className: "pagination_container" },
        react_1.default.createElement("span", { className: "go_to_page_wrapper" },
            "\u00A0\u00A0Go to page\u00A0:\u00A0",
            react_1.default.createElement("input", { type: "number", defaultValue: pageIndex, onKeyDown: (e) => {
                    if (e.key === "Enter") {
                        const page = e.currentTarget.value
                            ? Number(e.currentTarget.value) - 1
                            : 0;
                        table.setPageIndex(page);
                    }
                }, style: { width: "60px", textAlign: "center" }, min: 1, max: table === null || table === void 0 ? void 0 : table.getPageCount() }),
            "\u00A0"),
        react_1.default.createElement("span", null,
            react_1.default.createElement("span", null, "Showing\u00A0"),
            react_1.default.createElement("strong", null,
                recordsRangeFirst,
                " - ",
                recordsRangeLast,
                " of ",
                recordsTotal)),
        react_1.default.createElement("span", { className: "page_range" },
            react_1.default.createElement("span", null, "\u00A0Page\u00A0"),
            react_1.default.createElement("strong", null,
                pageIndex,
                " of ",
                pageCount,
                "\u00A0")),
        react_1.default.createElement("div", null,
            react_1.default.createElement("button", { title: "First Page", className: "pagination_btn", disabled: !table.getCanPreviousPage(), onClick: () => table.setPageIndex(0) },
                react_1.default.createElement(svg_1.TableFirstPageIcon, null)),
            "\u00A0",
            react_1.default.createElement("button", { title: "Previous Page", className: "pagination_btn", disabled: !table.getCanPreviousPage(), onClick: () => table.previousPage() },
                react_1.default.createElement(svg_1.TablePreviousPageIcon, null)),
            react_1.default.createElement("button", { title: "Next Page", className: "pagination_btn", disabled: !table.getCanNextPage(), onClick: () => table.nextPage() },
                react_1.default.createElement(svg_1.TableNextPageIcon, null)),
            "\u00A0",
            react_1.default.createElement("button", { title: "Last Page", className: "pagination_btn", disabled: !table.getCanNextPage(), onClick: () => table.setPageIndex(pageCount - 1) },
                react_1.default.createElement(svg_1.TableLastPageIcon, null)))));
}
exports.default = TanstackPagination;
