"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DebouncedInput = void 0;
const react_1 = require("react");
const svg_1 = require("../assets/svg");
require("./dist/Topbar.scss");
const DropdownMenu_1 = __importDefault(require("./DropdownMenu"));
const react_2 = __importDefault(require("react"));
function Topbar({ data, table, tableOptions, featuresOptions, }) {
    const [openSearch, setOpenSearch] = (0, react_1.useState)(false);
    const [openColumnHide, setOpenColumnHide] = (0, react_1.useState)(false);
    const { enableTopbar, enableFilter, enableSearch, enableColumnPadding, enableColumnHiding, enableGlobalFilter, } = featuresOptions;
    const { globalFilter, setGlobalFilter, openFilter, setOpenFilter, paddingIndex, setPaddingIndex, convertToXL, rowSelection, } = tableOptions;
    const selectedRow = [];
    const selectedRowKey = Object.keys(rowSelection);
    selectedRowKey.map((i) => selectedRow.push(data[parseInt(i)]));
    console.log(rowSelection);
    return (enableTopbar && (react_2.default.createElement("section", { className: "ts__topbar" },
        enableSearch && enableGlobalFilter && (react_2.default.createElement(react_2.default.Fragment, null,
            openSearch && (react_2.default.createElement("label", { className: "ts_search-field", htmlFor: "Search" },
                react_2.default.createElement(svg_1.SearchIcon, null),
                react_2.default.createElement(DebouncedInput, { value: globalFilter !== null && globalFilter !== void 0 ? globalFilter : "", onChange: (value) => setGlobalFilter(String(value)), placeholder: "Search" }))),
            react_2.default.createElement("button", { onClick: () => setOpenSearch(!openSearch), className: "ts__topbar__button ts__topbar__search" }, openSearch ? react_2.default.createElement(svg_1.CrossSearchIcon, null) : react_2.default.createElement(svg_1.SearchIcon, null)))),
        enableFilter && enableGlobalFilter && (react_2.default.createElement("button", { onClick: () => {
                setOpenFilter(!openFilter);
            }, className: "ts__topbar__button ts__topbar__filter" },
            react_2.default.createElement(svg_1.FilterIcon, null))),
        enableColumnHiding && (react_2.default.createElement("button", { onClick: () => setOpenColumnHide(!openColumnHide), className: "ts__topbar__button ts__topbar__filter" },
            react_2.default.createElement(svg_1.HideColumnIcon, null))),
        enableColumnPadding && (react_2.default.createElement("button", { onClick: setPaddingIndex, className: "ts__topbar__button ts__topbar__filter" },
            paddingIndex === 0 && react_2.default.createElement(svg_1.PaddingSM, null),
            paddingIndex === 1 && react_2.default.createElement(svg_1.PaddingMD, null),
            paddingIndex !== 0 && paddingIndex !== 1 && react_2.default.createElement(svg_1.PaddingLG, null))),
        selectedRow.length > 0 && (react_2.default.createElement("button", { onClick: () => {
                convertToXL(selectedRow);
            }, className: "ts__export__button" }, "Export")),
        openColumnHide && (react_2.default.createElement(DropdownMenu_1.default, { top: 50, right: 60 },
            react_2.default.createElement("div", { className: "ts__hide__show__button" },
                react_2.default.createElement("button", { defaultChecked: table.getIsSomeColumnsVisible(),
                    onClick: table.getToggleAllColumnsVisibilityHandler(), className: "ts__show__button" }, "Toggle All")),
            table.getAllLeafColumns().map((column) => {
                return (react_2.default.createElement("div", { key: column.id, className: "ts__column__visible" },
                    react_2.default.createElement("label", { className: "ts__column_visible_label" },
                        react_2.default.createElement("div", { className: "switch" },
                            react_2.default.createElement("input", { type: "checkbox",
                                checked: column.getIsVisible(),
                                onChange: column.getToggleVisibilityHandler() }),
                            react_2.default.createElement("span", { className: "slider round" })),
                        column.id)));
            }))))));
}
exports.default = Topbar;
function DebouncedInput(_a) {
    var { value: initialValue, onChange, debounce = 500 } = _a, props = __rest(_a, ["value", "onChange", "debounce"]);
    const [value, setValue] = (0, react_1.useState)(initialValue);
    (0, react_1.useEffect)(() => {
        setValue(initialValue);
    }, [initialValue]);
    (0, react_1.useEffect)(() => {
        const timeout = setTimeout(() => {
            onChange(value);
        }, debounce);
        return () => clearTimeout(timeout);
    }, [debounce, onChange, value]);
    console.log(value);
    return (react_2.default.createElement("input", Object.assign({}, props, { value: value, onChange: (e) => setValue(e.target.value) })));
}
exports.DebouncedInput = DebouncedInput;
