"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const XLSX = __importStar(require("xlsx"));
const useRezReactTable = () => {
    const [sorting, setSorting] = (0, react_1.useState)([]);
    const [columnVisibility, setColumnVisibility] = (0, react_1.useState)({});
    const [globalFilter, setGlobalFilter] = (0, react_1.useState)("");
    const [openFilter, setOpenFilter] = (0, react_1.useState)(false);
    const [isDropdownOpen, setIsDropdownOpen] = (0, react_1.useState)("");
    const [paddingIndex, setPaddingIndex] = (0, react_1.useState)(0);
    const [grouping, setGrouping] = (0, react_1.useState)([]);
    const [rowSelection, setRowSelection] = (0, react_1.useState)({});
    const [paginationState, setPaginationState] = (0, react_1.useState)({
        pageIndex: 0,
        pageSize: 20,
    });
    const togglePadding = () => {
        setPaddingIndex((paddingIndex + 1) % paddingGaps.length);
    };
    const paddingGaps = [`${"4px 8px"}`, `${"8px 12px"}`, `${"12px 16px"}`];
    const currentPadding = paddingGaps[paddingIndex];
    const convertToXL = (data) => {
        const workbok = XLSX.utils.json_to_sheet(data);
        const workbook = XLSX.utils.book_new();
        XLSX.utils.book_append_sheet(workbook, workbok, "Employees");
        XLSX.writeFile(workbook, "Employee List.xlsx", { compression: true });
    };
    const hookOptions = {
        openFilter: openFilter,
        setOpenFilter: setOpenFilter,
        isDropdownOpen: isDropdownOpen,
        setIsDropdownOpen: setIsDropdownOpen,
        paddingIndex: paddingIndex,
        currentPadding: currentPadding,
        setPaddingIndex: togglePadding,
        sorting: sorting,
        setSorting: setSorting,
        columnVisibility: columnVisibility,
        setColumnVisibility: setColumnVisibility,
        globalFilter: globalFilter,
        setGlobalFilter: setGlobalFilter,
        grouping: grouping,
        setGrouping: setGrouping,
        rowSelection: rowSelection,
        setRowSelection: setRowSelection,
        pagination: paginationState,
        setPagination: setPaginationState,
        convertToXL: convertToXL
    };
    return hookOptions;
};
exports.default = useRezReactTable;
