"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const utilityComponents_1 = require("../utils/utilityComponents");
const react_2 = __importDefault(require("react"));
const useTableColumns = () => {
    const defaultColumns = (0, react_1.useMemo)(() => [
        {
            id: "select",
            header: ({ table }) => (react_2.default.createElement(utilityComponents_1.IndeterminateCheckbox, { checked: table.getIsAllRowsSelected(),
                indeterminate: table.getIsSomeRowsSelected(),
                onChange: table.getToggleAllRowsSelectedHandler() })),
            cell: ({ row }) => (react_2.default.createElement("div", { className: "px-1" },
                react_2.default.createElement(utilityComponents_1.IndeterminateCheckbox, { checked: row.getIsSelected(),
                    disabled: !row.getCanSelect(),
                    indeterminate: row.getIsSomeSelected(),
                    onChange: row.getToggleSelectedHandler() }))),
        },
        {
            header: "ID",
            accessorKey: "id",
            id: "id",
        },
        {
            header: "NAME",
            accessorKey: "name",
            id: "name",
            // size: 500,
            meta: {
                align: "left",
            },
            // size:500
        },
        {
            header: "GENDER",
            accessorKey: "gender",
            meta: {
                align: "center",
            },
            id: "gender",
        },
        {
            header: "URL",
            accessorKey: "location.url",
            id: "location.url",
            // size: 200,
            maxSize: 200,
        },
        {
            header: "CREATED ON",
            accessorKey: "created",
            id: "created",
        },
        {
            header: "LOCATION NAME",
            accessorKey: "location.name",
            id: "location_name",
        },
        {
            header: "URL",
            accessorKey: "location.url",
            id: "url",
            meta: {
                align: "right",
            },
        },
        {
            header: "SPECIES",
            accessorKey: "species",
            id: "species",
        },
        // {
        //   header: "TYPE",
        //   accessorKey: "type",
        //   id: "type",
        // },
        // {
        //   header: "STATUS",
        //   accessorKey: "status",
        //   id: "status",
        // },
        // {
        //   header: "ORIGIN",
        //   columns: [
        //     {
        //       header: "NAME",
        //       accessorKey: "origin.name",
        //       id: "origin.name",
        //       minSize: 300,
        //     },
        //     {
        //       header: "url",
        //       accessorKey: "origin.url",
        //       id: "origin.url",
        //       minSize: 300,
        //     },
        //   ],
        // },
    ], []);
    return { defaultColumns };
};
exports.default = useTableColumns;
