import { ColumnDef, GroupingState, PaginationState, RowSelectionState, SortingState, VisibilityState } from "@tanstack/react-table";
import { CSSProperties, Dispatch, MouseEventHandler, SetStateAction } from "react";
export interface TableProps<T> {
    style?: string;
    data: [];
    column: ColumnDef<T>[];
    tableOptions: REZ_tableOptionsWithState;
    paginationTotalRows: number;
    featureOptions?: REZ_tableOptions;
}
export interface align {
    align: "left" | "center" | "right";
}
export interface REZ_tableOptions {
    enableColumnResizing?: boolean;
    enableColumnReording?: boolean;
    enableSorting?: boolean;
    enableTopbar?: boolean;
    enableSearch?: boolean;
    enableFilter?: boolean;
    enableGlobalFilter?: boolean;
    enableFullScreen?: boolean;
    enableColumnPadding?: boolean;
    enableColumnHiding?: boolean;
    enableVerticalDots?: boolean;
    enableColumnPinning?: boolean;
    enableColumnGrouping?: boolean;
    enableServerSidePagination?: boolean;
    cellPadding?: {
        sm?: CSSProperties;
        md?: CSSProperties;
        lg?: CSSProperties;
    };
}
export interface REZ_tableOptionsWithState {
    openFilter: boolean;
    setOpenFilter: Dispatch<SetStateAction<boolean>>;
    isDropdownOpen: string;
    setIsDropdownOpen: Dispatch<SetStateAction<string>>;
    paddingIndex: number;
    setPaddingIndex: MouseEventHandler<HTMLButtonElement>;
    currentPadding: string | CSSProperties;
    setSorting: Dispatch<SetStateAction<SortingState>>;
    sorting: SortingState;
    setColumnVisibility: Dispatch<SetStateAction<object>>;
    columnVisibility: VisibilityState;
    globalFilter: string;
    setGlobalFilter: Dispatch<SetStateAction<string>>;
    grouping: GroupingState;
    setGrouping: Dispatch<SetStateAction<GroupingState>>;
    rowSelection: RowSelectionState;
    setRowSelection: Dispatch<React.SetStateAction<object>>;
    pagination: PaginationState;
    setPagination: Dispatch<SetStateAction<PaginationState>>;
    convertToXL: (data: unknown[]) => void;
}
