"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getColumnJustifyContent = exports.getColumnPinningStylesBody = exports.getColumnPinningStyles = void 0;
const getColumnPinningStyles = (column) => {
    const isPinned = column.getIsPinned();
    const isLastLeftPinnedColumn = isPinned === "left" && column.getIsLastColumn("left");
    const isFirstRightPinnedColumn = isPinned === "right" && column.getIsFirstColumn("right");
    return {
        boxShadow: isLastLeftPinnedColumn
            ? "-4px 0 4px -4px gray inset"
            : isFirstRightPinnedColumn
                ? "4px 0 4px -4px gray inset"
                : undefined,
        background: isPinned ? "#1a1b1e" : undefined,
        left: isPinned === "left" ? `${column.getStart("left")}px` : undefined,
        right: isPinned === "right" ? `${column.getAfter("right")}px` : undefined,
        opacity: isPinned ? 0.95 : 1,
        position: isPinned ? "sticky" : "relative",
        width: column.getSize(),
        zIndex: isPinned ? 1 : 0,
    };
};
exports.getColumnPinningStyles = getColumnPinningStyles;
const getColumnPinningStylesBody = (column) => {
    const isPinned = column.getIsPinned();
    const isLastLeftPinnedColumn = isPinned === "left" && column.getIsLastColumn("left");
    const isFirstRightPinnedColumn = isPinned === "right" && column.getIsFirstColumn("right");
    return {
        boxShadow: isLastLeftPinnedColumn
            ? "-4px 0 4px -4px gray inset"
            : isFirstRightPinnedColumn
                ? "4px 0 4px -4px gray inset"
                : undefined,
        background: isPinned ? "#2c2d31" : undefined,
        left: isPinned === "left" ? `${column.getStart("left")}px` : undefined,
        right: isPinned === "right" ? `${column.getAfter("right")}px` : undefined,
        opacity: isPinned ? 0.95 : 1,
        position: isPinned ? "sticky" : "relative",
        width: column.getSize(),
        zIndex: isPinned ? 1 : 0,
    };
};
exports.getColumnPinningStylesBody = getColumnPinningStylesBody;
const getColumnJustifyContent = (alignment) => {
    if (alignment === "left") {
        return "flex-start";
    }
    else if (alignment === "right") {
        return "flex-end";
    }
    else if (alignment === "center") {
        return "center";
    }
};
exports.getColumnJustifyContent = getColumnJustifyContent;
